'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _toConsumableArray2 = require('babel-runtime/helpers/toConsumableArray');

var _toConsumableArray3 = _interopRequireDefault(_toConsumableArray2);

var _assign = require('babel-runtime/core-js/object/assign');

var _assign2 = _interopRequireDefault(_assign);

var _objectWithoutProperties2 = require('babel-runtime/helpers/objectWithoutProperties');

var _objectWithoutProperties3 = _interopRequireDefault(_objectWithoutProperties2);

var _getPrototypeOf = require('babel-runtime/core-js/object/get-prototype-of');

var _getPrototypeOf2 = _interopRequireDefault(_getPrototypeOf);

var _possibleConstructorReturn2 = require('babel-runtime/helpers/possibleConstructorReturn');

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require('babel-runtime/helpers/inherits');

var _inherits3 = _interopRequireDefault(_inherits2);

var _classCallCheck2 = require('babel-runtime/helpers/classCallCheck');

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require('babel-runtime/helpers/createClass');

var _createClass3 = _interopRequireDefault(_createClass2);

var _fp = require('lodash/fp');

var _fp2 = _interopRequireDefault(_fp);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var loadScript = function loadScript() {
  var script = document.createElement('script');
  script.async = 'true';
  script.type = 'text/javascript';
  script.src = 'https://wchat.freshchat.com/js/widget.js';
  document.head.appendChild(script);
};

var Queue = function () {
  function Queue() {
    (0, _classCallCheck3.default)(this, Queue);

    this.data = [];
    this.index = 0;
  }

  (0, _createClass3.default)(Queue, [{
    key: 'queue',
    value: function queue(value) {
      this.data.push(value);
    }
  }, {
    key: 'dequeue',
    value: function dequeue() {
      if (this.index > -1 && this.index < this.data.length) {
        var result = this.data[this.index++];

        if (this.isEmpty()) {
          this.reset();
        }

        return result;
      }
    }
  }, {
    key: 'dequeueAll',
    value: function dequeueAll(cb) {
      if (!_fp2.default.isFunction(cb)) {
        throw new Error('Please provide a callback');
      }

      while (!this.isEmpty) {
        var _dequeue = this.dequeue(),
            method = _dequeue.method,
            args = _dequeue.args;

        cb(method, args);
      }

      this.reset();
    }
  }, {
    key: 'reset',
    value: function reset() {
      this.data.length = 0;
      this.index = 0;
    }
  }, {
    key: 'isEmpty',
    get: function get() {
      return this.index >= this.data.length;
    }
  }]);
  return Queue;
}();

var FreshChat = function (_React$Component) {
  (0, _inherits3.default)(FreshChat, _React$Component);

  function FreshChat(props) {
    (0, _classCallCheck3.default)(this, FreshChat);

    var _this = (0, _possibleConstructorReturn3.default)(this, (FreshChat.__proto__ || (0, _getPrototypeOf2.default)(FreshChat)).call(this, props));

    var token = props.token,
        moreProps = (0, _objectWithoutProperties3.default)(props, ['token']);


    if (!token) {
      throw new Error('token is required');
    }

    _this.init((0, _assign2.default)({
      host: 'https://wchat.freshchat.com',
      token: token
    }, moreProps));
    return _this;
  }

  (0, _createClass3.default)(FreshChat, [{
    key: 'init',
    value: function init(settings) {
      var _this2 = this;

      if (settings.onInit) {
        var tmp = settings.onInit;
        settings.onInit = function () {
          return tmp(_this2.widget);
        };
      }

      if (window.fcWidget) {
        window.fcWidget.init(settings);
      } else {
        this.lazyInit(settings);
      }
    }
  }, {
    key: 'lazyInit',
    value: function lazyInit(settings) {
      var _this3 = this;

      window.fcSettings = settings;
      this.earlyCalls = new Queue();
      this.fakeWidget = this.mockMethods(availableMethods);

      loadScript();

      var interval = setInterval(function () {
        if (window.fcWidget) {
          clearInterval(interval);
          try {
            _this3.earlyCalls.dequeueAll(function (method, value) {
              var _window$fcWidget;

              (_window$fcWidget = window.fcWidget)[method].apply(_window$fcWidget, (0, _toConsumableArray3.default)(value));
            });
          } catch (e) {
            console.error(e);
          }
        }
      }, 1000);
    }
  }, {
    key: 'mockMethods',
    value: function mockMethods(methods) {
      var _this4 = this;

      var obj = {};
      methods.forEach(function (method) {
        obj = _fp2.default.set(method, _this4.queueMethod(method), obj);
      });
      return obj;
    }
  }, {
    key: 'queueMethod',
    value: function queueMethod(method) {
      var _this5 = this;

      return function () {
        for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
          args[_key] = arguments[_key];
        }

        _this5.earlyCalls.queue({ method: method, args: args });
      };
    }
  }, {
    key: 'render',
    value: function render() {
      return false;
    }
  }, {
    key: 'widget',
    get: function get() {
      return window.fcWidget || this.fakeWidget;
    }
  }]);
  return FreshChat;
}(_react2.default.Component);

var availableMethods = ['close', 'destroy', 'hide', 'init', 'isInitialized', 'isLoaded', 'isOpen', 'off', 'on', 'open', 'setConfig', 'setExternalId', 'setFaqTags', 'setTags', 'track', 'user.show', 'user.track', 'user.user', 'user.clear', 'user.create', 'user.get', 'user.isExists', 'user.setEmail', 'user.setFirstName', 'user.setLastName', 'user.setMeta', 'user.setPhone', 'user.setPhoneCountryCode', 'user.setProperties', 'user.update'];

exports.default = FreshChat;